/***************************************************************************
 *   Copyright (C) 2006 by Dirk Hartmann   *
 *   dirk.hartmann@sitter-net.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <iostream>
#include <sstream>


std::string int2str(const int &x)
{
	std::ostringstream o;
	o << x;
	return(o.str());
}

void execute_command(const std::string &command, std::string &result, unsigned int maxAnswerLength)
{
	FILE* pipe;
	int bytes = 0;
	/* define buffersize this is the max answer length */
	const int BUFFERSIZE = 1024;

	/* create buffer space */
	char filebuffer[BUFFERSIZE];

	/* reset the result string */
	result = "";
	
	/*open the stream via popen*/
	pipe = popen (command.c_str(), "r");
	
	/*read from the stream*/
	while (result.length() <= maxAnswerLength) {
		bytes = fread (filebuffer, 1, BUFFERSIZE, pipe);
		filebuffer[bytes] = '\0'; //terminate the string
		if (bytes < 1)
			break;
		else
			result += filebuffer;
	}
	
	/* now close the pipe and clean up the child */
	pclose(pipe);
}


